package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.utils.MongoDB;
import gq.unurled.raxen.utils.Mysql;
import lombok.Getter;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

import java.io.File;
import java.io.IOException;
import java.util.stream.IntStream;

import static gq.unurled.raxen.utils.Utils.*;

public class StorageManager {

    private static Raxen main;
    private static FileConfiguration config;

    @Getter
    private static MongoDB mongo;
    @Getter
    private static String currently;
    @Getter
    private static Mysql mysql;

    public StorageManager(Raxen main) {
        this.main = main.getPlugin();
        this.config = main.getConfig();
        this.mongo = new MongoDB();
        this.connect();
    }

    public static void connect() {
        String s = (String) config.get("storage");
        log(s);
        if(s.equalsIgnoreCase("MONGODB")) {
            mongo.connect();
            currently = "MONGODB";
            warn("'" + s + "'");
        }

        if(s.equalsIgnoreCase("MYSQL")) {
            error("Currently not implemented, switching to YML");
            currently = "YML";
            warn("'" + s + "'");
        }
        else {
            currently = "YML";
            warn("'" + s + "'");
        }
    }

    public static void disconnect() {
        mysql.disconnect();
    }

    public static FileConfiguration createYml(Player player) {
        File customFile;
        FileConfiguration customConfig;
        log(main.getDataFolder() + "/playerInfo/" + player.getUniqueId() + "/playerInfo.yml");
        customFile = new File(main.getDataFolder() + "/playerInfo/" + player.getUniqueId(), "/playerInfo.yml");

        if (!customFile.exists()) {
            customFile.getParentFile().mkdirs();
            main.saveResource(main.getDataFolder() + "/playerInfo/" + player.getUniqueId() + "/playerInfo.yml", false);
        }

        customConfig = new YamlConfiguration();
        try {
            customConfig.load(customFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        return customConfig;
    }

}